%define modname pytest

Name:           python-%{modname}
Version:        3.0.5
Release:        %mkrel 4
Summary:        Simple powerful testing with Python

Group:          Development/Python
License:        MIT
URL:            http://pytest.org
Source0:        https://files.pythonhosted.org/packages/source/p/%{modname}/%{modname}-%{version}.tar.gz

BuildArch:      noarch
Obsoletes:      python-test < 3.0.5-2
Provides:       python-test = %{version}-%{release}
Provides:       python2-pytest = %{version}-%{release}
BuildRequires:  python-devel
BuildRequires:  python-setuptools
Requires:       python-setuptools
BuildRequires:  python-py
Requires:       python-py
BuildRequires:  python-sphinx
BuildRequires:  python-sphinx_rtd_theme
BuildRequires:  python-docutils
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-py

# if pexpect is present, the testsuite fails on F19 due to
# http://bugs.python.org/issue17998
#BuildRequires:  python-pexpect
BuildRequires:  python-mock
BuildRequires:  python-twisted-core
BuildRequires:  python3-mock
BuildRequires:  python-hypothesis
BuildRequires:  python3-hypothesis


%description
py.test provides simple, yet powerful testing for Python.


%package -n python3-%{modname}
Summary:        Simple powerful testing with Python
Group:          Development/Python
Obsoletes:      python3-test < 3.0.5-2
Provides:       python3-test = %{version}-%{release}
Requires:       python3-setuptools
Requires:       python3-py


%description -n python3-%{modname}
py.test provides simple, yet powerful testing for Python.

%package doc
Summary:	Documentation for pytest
Group:		Development/Python
BuildArch: noarch

%description doc
This package contains documentation for pytest.

%prep
%setup -q -n %{modname}-%{version}

cp -a . %{py3dir}


%build
%py2_build

for l in doc/* ; do
  make -C $l html PYTHONPATH=$(pwd)
done
for f in README CHANGELOG CONTRIBUTING ; do
  rst2html ${f}.rst > ${f}.html
done

pushd %{py3dir}
%py3_build
popd


%install
%py2_install
mv %{buildroot}%{_bindir}/pytest %{buildroot}%{_bindir}/pytest-%{python2_version}
ln -snf pytest-%{python2_version} %{buildroot}%{_bindir}/pytest-2
mv %{buildroot}%{_bindir}/py.test %{buildroot}%{_bindir}/py.test-%{python2_version}
ln -snf py.test-%{python2_version} %{buildroot}%{_bindir}/py.test-2

# remove shebangs from all scripts
find %{buildroot}%{python2_sitelib} -name '*.py' \
     -exec sed -i -e '1{/^#!/d}' {} \;

pushd %{py3dir}
%py3_install
mv %{buildroot}%{_bindir}/pytest %{buildroot}%{_bindir}/pytest-%{python3_version}
ln -snf pytest-%{python3_version} %{buildroot}%{_bindir}/pytest-3
mv %{buildroot}%{_bindir}/py.test %{buildroot}%{_bindir}/py.test-%{python3_version}
ln -snf py.test-%{python3_version} %{buildroot}%{_bindir}/py.test-3

# remove shebangs from all scripts
find %{buildroot}%{python3_sitelib} -name '*.py' \
     -exec sed -i -e '1{/^#!/d}' {} \;

popd

mkdir -p _htmldocs/html
for l in doc/* ; do
  # remove hidden file
  rm ${l}/_build/html/.buildinfo
  mv ${l}/_build/html _htmldocs/html/${l##doc/}
done


# use 2.X per default
ln -snf pytest-%{python2_version} %{buildroot}%{_bindir}/pytest
ln -snf py.test-%{python2_version} %{buildroot}%{_bindir}/py.test



%check
PATH=%{buildroot}%{_bindir}:${PATH} \
PYTHONPATH=%{buildroot}%{python2_sitelib} \
# As reported by ArchLinux, some tests fails under python2
#  %{buildroot}%{_bindir}/py.test-2.* -r s testing 
pushd %{py3dir}
PATH=%{buildroot}%{_bindir}:${PATH} \
PYTHONPATH=%{buildroot}%{python3_sitelib} \
  %{buildroot}%{_bindir}/py.test-%{python3_version} -r s testing
popd


%files
%doc CHANGELOG.html README.html CONTRIBUTING.html
%license LICENSE
%{_bindir}/pytest
%{_bindir}/pytest-2
%{_bindir}/pytest-%{python2_version}
%{_bindir}/py.test
%{_bindir}/py.test-2
%{_bindir}/py.test-%{python2_version}
%{python2_sitelib}/*


%files -n python3-%{modname}
%doc CHANGELOG.html README.html CONTRIBUTING.html
%license LICENSE
%{_bindir}/pytest-3
%{_bindir}/pytest-%{python3_version}
%{_bindir}/py.test-3
%{_bindir}/py.test-%{python3_version}
%{python3_sitelib}/*

%files doc
%doc _htmldocs/html


%changelog
* Sun May 14 2017 ngompa <ngompa> 3.0.5-4.mga6
+ Revision: 1101162
- Add Fedora-compatible Provides and fix legacy pythonX-test Provides

* Mon Jan 09 2017 philippem <philippem> 3.0.5-3.mga6
+ Revision: 1080744
- add provides for python{3}-test

* Sun Jan 08 2017 philippem <philippem> 3.0.5-2.mga6
+ Revision: 1080650
- update to 3.0.5, obsolete python-test and python3-test

  + bcornec <bcornec>
    - Fix binaries delivered using macro for python version

* Wed Nov 30 2016 ngompa <ngompa> 2.9.2-2.mga6
+ Revision: 1071092
- Add py.test-2 and py.test-3 symlinks

* Fri Oct 28 2016 philippem <philippem> 2.9.2-1.mga6
+ Revision: 1063821
- update to 2.9.2

* Fri Feb 19 2016 umeabot <umeabot> 2.8.2-2.mga6
+ Revision: 970803
- Mageia 6 Mass Rebuild

* Fri Oct 09 2015 philippem <philippem> 2.8.2-1.mga6
+ Revision: 888493
- use new macros, disable test for Python2, make Python3 as default

  + tv <tv>
    - new release

* Fri Oct 09 2015 tv <tv> 2.7.3-1.mga6
+ Revision: 887981
- new release
- rebuild for python 3.5
- BR python-sphinx_rtd_theme
- rebuild for python 3.5

* Fri Aug 28 2015 philippem <philippem> 2.7.2-1.mga6
+ Revision: 870483
- update to 2.7.2

* Wed Oct 15 2014 umeabot <umeabot> 2.6.1-4.mga5
+ Revision: 748107
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 2.6.1-3.mga5
+ Revision: 726919
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 2.6.1-2.mga5
+ Revision: 688284
- Mageia 5 Mass Rebuild

* Tue Sep 09 2014 juancho <juancho> 2.6.1-1.mga5
+ Revision: 674085
- Updated to 2.6.1
- Updated to 2.6.1

* Sat May 31 2014 pterjan <pterjan> 2.5.2-2.mga5
+ Revision: 628969
- Rebuild for new Python

* Tue Mar 11 2014 philippem <philippem> 2.5.2-1.mga5
+ Revision: 602545
- imported package python-pytest

